unit NWHSETUP;
{
Copyright (C) 2007 Paul Toth <tothpaul@free.fr>
 http://tothpaul.free.fr

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,NWHPrint;

type
  TNWHostPrinterSetupForm = class(TForm)
    Panel: TGroupBox;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Device: TLabel;
    HostName: TEdit;
    MSGQName: TEdit;
    MSGQLib: TEdit;
    PPS1: TComboBox;
    PPS2: TComboBox;
    ENV: TComboBox;
    TypeModel: TComboBox;
    WSCSTName: TEdit;
    WSCSTLib: TEdit;
    DevName: TEdit;
    Label8: TLabel;
    OK: TButton;
    Annuler: TButton;
    Printer: TEdit;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure OKClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    procedure GetPrinterInfo(Printer:TNWHostPrinter);
    procedure SetPrinterInfo(Printer:TNWHostPrinter);
  end;

var
  NWHostPrinterSetupForm: TNWHostPrinterSetupForm;

implementation

Uses
 WinSpool, NWPDlg;

{$R *.DFM}

function DefaultPrinter:string;
 var
  pDefaultPrinter: array[0..79] of Char;
  i:integer;
 begin
  GetProfileString('windows', 'device', '', pDefaultPrinter,SizeOf(pDefaultPrinter) - 1);
  Result:=pDefaultPrinter;
  i:=pos(',',Result);
  if i>0 then SetLength(Result,i-1);
 end;

procedure TNWHostPrinterSetupForm.FormCreate(Sender: TObject);
begin
// Default
 TypeModel.ItemIndex:=3;
 PPS1.ItemIndex:=5;
 PPS2.Items:=PPS1.Items;
 PPS2.ItemIndex:=0;
 ENV.ItemIndex:=0;
end;

procedure TNWHostPrinterSetupForm.GetPrinterInfo(Printer:TNWHostPrinter);

 procedure setlist(list:TComboBox; value:string);
  begin
   list.itemindex:=list.items.indexof(value);
  end;

 begin
  Caption:=Printer.HostName;
  Self.Printer.Text:=Printer.Printer;
//  setlist(printers,printer.printer);
  HostName.Text:=Printer.HostName;
  DevName.Text :=Printer.DevName;
  MSGQName.Text:=GetName(Printer.MSQG);
  MSGQLib.Text:=GetLib(Printer.MSQG);
  TypeModel.Text:=Printer.Model;
  WSCSTName.Text:=GetName(Printer.WSCST);
  WSCSTLib.Text:=GetLib(Printer.WSCST);
//  PPS1.Text:=Printer.Paper1;
  setlist(pps1,printer.paper1);
//  PPS2.Text:=Printer.Paper2;
  setlist(pps2,printer.paper2);
//  ENV.Text:=Printer.Envelope;
  setlist(env,printer.envelope);
 end;

procedure TNWHostPrinterSetupForm.SetPrinterInfo(Printer:TNWHostPrinter);
 begin
//  Printer.Disconnect;
  Printer.Printer :=Self.Printer.Text;
  Printer.HostName:=HostName.Text;
  Printer.DevName :=DevName.Text;
  Printer.MSQG    :=MSGQLib.Text+'/'+MSGQName.Text;
  Printer.Model   :=TypeModel.Text;
  Printer.WSCST   :=WSCSTLib.Text+'/'+WSCSTName.Text;
  Printer.Paper1  :=PPS1.Text;
  Printer.Paper2  :=PPS2.Text;
  Printer.Envelope:=ENV.Text;
 end;

Function NotEmpty(Edits:array of TEdit):boolean;
 var
  i:integer;
 begin
  Result:=False;
  for i:=Low(Edits) to High(Edits) do begin
   if Edits[i].Text='' then begin
    Edits[i].SetFocus;
    Beep;
    Exit;
   end;
  end;
  Result:=True;
 end;

procedure TNWHostPrinterSetupForm.OKClick(Sender: TObject);
begin
 if NotEmpty([HostName,DevName]) then ModalResult:=mrOK;
end;

procedure TNWHostPrinterSetupForm.Button1Click(Sender: TObject);
begin
 with TNWPrinter.Create(Self) do begin
  Printer:=Self.Printer.Text;
  if ShowModal=mrOK then Self.Printer.Text:=Printer;
  Free;
 end;
end;

end.
