unit NWP4001;
{
Copyright (C) 2007 Paul Toth <tothpaul@free.fr>
 http://tothpaul.free.fr

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ImgList, ComCtrls, Buttons, NWHPrint,
  Menus, Novell;

Const
  Sign='Print Server File v1.0'#26;

type
  THeure=record
   H,M:word;
  end;

  TForm1 = class(TForm)
    pnTools: TPanel;
    ListView1: TListView;
    ImageList1: TImageList;
    ImageList2: TImageList;
    vStyle4: TSpeedButton;
    vStyle3: TSpeedButton;
    vStyle2: TSpeedButton;
    vStyle1: TSpeedButton;
    MainMenu1: TMainMenu;
    mnFichier: TMenuItem;
    Ouvrir1: TMenuItem;
    N7: TMenuItem;
    Supprimer1: TMenuItem;
    Proprits1: TMenuItem;
    N8: TMenuItem;
    Fermer1: TMenuItem;
    Edition1: TMenuItem;
    Affichage1: TMenuItem;
    Barredoutils1: TMenuItem;
    Barredtat1: TMenuItem;
    N4: TMenuItem;
    mvStyle1: TMenuItem;
    mvStyle2: TMenuItem;
    mvStyle3: TMenuItem;
    mvStyle4: TMenuItem;
    N1: TMenuItem;
    Apropos1: TMenuItem;
    bdStart: TSpeedButton;
    btDelete: TSpeedButton;
    bdProperty: TSpeedButton;
    StatusBar: TStatusBar;
    bdStop: TSpeedButton;
    btAddPrinter: TSpeedButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Enregistrer1: TMenuItem;
    EnregistrerSous1: TMenuItem;
    Dmarrer1: TMenuItem;
    Arrter1: TMenuItem;
    Bevel1: TBevel;
    N2: TMenuItem;
    StartStop: TMenuItem;
    SpeedButton1: TSpeedButton;
    MinuteTimer: TTimer;
    Historique1: TMenuItem;
    N3: TMenuItem;
    procedure vStyle1Click(Sender: TObject);
    procedure Fermer1Click(Sender: TObject);
    procedure ListView1DblClick(Sender: TObject);
    procedure Ouvrir1Click(Sender: TObject);
    procedure Enregistrer1Click(Sender: TObject);
    procedure EnregistrerSous1Click(Sender: TObject);
    procedure btTagClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btAddPrinterClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Barredoutils1Click(Sender: TObject);
    procedure Barredtat1Click(Sender: TObject);
    procedure Apropos1Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure MinuteTimerTimer(Sender: TObject);
    procedure StartStopClick(Sender: TObject);
    procedure Historique1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Dclarations prives }
    FileName:string;
    Stop,Start:THeure;
    Log:TStringList;
    procedure Load(AFileName:string);
    Function NewPrinter:TNWHostPrinter;
    procedure PrinterConnect(Sender:TObject);
    procedure PrinterClose(Sender:TObject);
    procedure PrinterError(Sender:TObject);
    procedure PrinterChange(Sender:TObject);
    procedure PrinterPrintError(Sender:TObject);
  public
    { Dclarations publiques }
    procedure SetStatus(Value:string);
    procedure SetInfo(Value:string);
    property Status:string write SetStatus;
    property Info:string write SetInfo;
    procedure Clear;
    procedure ReleaseServer;
    procedure HoldServer;
  end;

var
  Form1: TForm1;

implementation

Uses
 NWHSetup,RegEdit, NWP400A, NWP4003, NWP4004, NWP4005, NWPDlg;

{$R *.DFM}

function IntToStr2(i:integer):string;
 begin
  Result:=IntToStr(i);
  if length(Result)=1 then Result:='0'+Result;
 end;

procedure TForm1.FormCreate(Sender: TObject);
var
 NPS:string;
 s:string;
begin
 Log:=TStringList.Create;
 Status:='Application lance';
 Stop.H:=18;
 Stop.M:=30;
 Start.H:=07;
 Start.M:=00;
 if ParamCount>0 then begin
  Load(ParamStr(1));
 end else begin
  NPS:=ReadRegString(HKEY_CLASSES_ROOT,'.NPS','','');
  if NPS='' then begin
   If Application.MessageBox(
    'Voulez-vous associer les fichier NPS  cette application ?',
    'Confirmation',
    mb_yesno or mb_iconquestion
   )<>mrYes then exit;
   WriteRegString(HKEY_CLASSES_ROOT,'.NPS','','NetwarePrintServerFile');
   NPS:='NetwarePrintServerFile';
  end;
  s:=ReadRegString(HKEY_CLASSES_ROOT,NPS,'','');
  if s='' then WriteRegString(HKEY_CLASSES_ROOT,NPS,'','Netware Print Server File v1.0');
  WriteRegString(HKEY_CLASSES_ROOT,NPS+'\shell\open\command','',ParamStr(0)+' %1');
  WriteRegString(HKEY_CLASSES_ROOT,NPS+'\DefaultIcon','',ParamStr(0)+',0');
 end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 Clear;
 Log.Free;
end;

procedure TForm1.Fermer1Click(Sender: TObject);
begin
 Application.Terminate;
end;

procedure TForm1.Clear;
 var
  i:integer;
 begin
  for i:=ListView1.Items.Count-1 downto 1 do begin
   with ListView1.Items[i] do begin
    TNWHostPrinter(Data).Free;
    Free;
   end;
  end;
 end;

procedure TForm1.vStyle1Click(Sender: TObject);
var
 i:integer;
begin
 i:=(Sender as TComponent).Tag;
 ListView1.ViewStyle:=TViewStyle(i);
 if Sender is TMenuItem then begin
  TMenuItem(Sender).Checked:=True;
  case i of
   0: vStyle1.Down:=True;
   1: vStyle2.Down:=True;
   2: vStyle3.Down:=True;
   3: vStyle4.Down:=True;
  end;
 end else begin
  case i of
   0: mvStyle1.Checked:=True;
   1: mvStyle2.Checked:=True;
   2: mvStyle3.Checked:=True;
   3: mvStyle4.Checked:=True;
  end;
 end;

end;

procedure TForm1.ListView1DblClick(Sender: TObject);
var
 Item:TListItem;
begin
 Item:=ListView1.Selected;
 if Item=nil then exit;
 if Item.ImageIndex=0 then begin
  btAddPrinterClick(Self)
 end else begin
  TNWHostPrinter(Item.Data).Setup;
  Item.Caption:=TNWHostPrinter(Item.Data).DevName;
 end;
end;

procedure TForm1.Ouvrir1Click(Sender: TObject);
begin
 if OpenDialog1.Execute then Load(OpenDialog1.FileName);
end;

Function TForm1.NewPrinter:TNWHostPrinter;
 begin
  Result:=TNWHostPrinter.Create(nil);
  Result.OnConnect:=PrinterConnect;
  Result.OnClose  :=PrinterClose;
  Result.OnError  :=PrinterError;
  Result.OnPrintError:=PrinterPrintError;
  Result.OnChange :=PrinterChange;
 end;

procedure TForm1.btAddPrinterClick(Sender: TObject);
 var
  item:TListItem;
 begin
  with TNWHostPrinterSetupForm.Create(Application) do begin
   if ShowModal=mrOK then begin
    Item:=ListView1.Items.Add;
    with Item do begin
     Data:=NewPrinter;
     TNWHostPrinter(Data).Tag:=integer(item);
     ImageIndex:=1;
     SetPrinterInfo(Data);
     Caption:=TNWHostPrinter(Data).DevName;
     SubItems.Add('END');
     SubItems.Add('');
    end;
   end;
   Free;
  end;
 end;

Procedure TForm1.Load(AFileName:string);
var
 fs:TFileStream;
 item:TListItem;
 s:string;
begin
  Clear;
  FileName:=AFileName;
  fs:=TFileStream.Create(FileName,fmOpenRead);
  try
    s:=Sign;
    fs.readBuffer(s[1],Length(s));
    if s<>Sign then begin
     raise Exception.create('Fichier invalide');
    end;
    fs.ReadBuffer(Start,SizeOf(Start));
    fs.ReadBuffer(Stop ,SizeOf(Stop ));
    while fs.Position<fs.Size do begin
     Item:=ListView1.Items.Add;
     with Item do begin
      ImageIndex:=1;
      SubItems.Add('END');
      SubItems.Add('');
      Data:=NewPrinter;
      try
       TNWHostPrinter(Data).Tag:=integer(item);
       fs.ReadComponent(TNWHostPrinter(Data));
       Caption:=TNWHostPrinter(Data).DevName;
      except
       on e:Exception do begin
        showMessage(e.message);
        Item.free;
       end;
      end;
     end;
    end;
    fs.Free;
    Status:='Fichier '+FileName+' charg';
  except
   showmessage('Impossible d''ouvrir '+FileName);
  end;
end;

procedure TForm1.Enregistrer1Click(Sender: TObject);
var
 fs:TFileStream;
 i:integer;
 h:TNWHostPrinter;
 t:integer;
 s:string;
begin
 if FileName='' then EnregistrerSous1Click(Self) else begin
  fs:=TFileStream.Create(FileName,fmOpenWrite or fmCreate);
  s:=Sign;
  fs.WriteBuffer(s[1],Length(s));
  fs.WriteBuffer(Start,SizeOf(Start));
  fs.WriteBuffer(Stop ,SizeOf(Stop ));
  for i:=1 to ListView1.Items.Count-1 do begin
   h:=TNWHostPrinter(ListView1.Items[i].Data);
   t:=h.tag; // DO NOT SAVE TAG !!!
   h.tag:=0;
   fs.WriteComponent(h);
   h.tag:=t;
  end;
  fs.Free;
  Status:='Fichier '+FileName+' enregistr';
 end;
end;

procedure TForm1.EnregistrerSous1Click(Sender: TObject);
begin
 SaveDialog1.FileName:=FileName;
 if SaveDialog1.Execute then begin
  FileName:=SaveDialog1.FileName;
  Enregistrer1Click(Self);
 end;
end;

procedure TForm1.btTagClick(Sender: TObject);
var
 Item:TListItem;
begin
 Item:=ListView1.Selected; if Item=nil then exit;
 if Item.Data=nil then exit; // Nouveau
 case TControl(Sender).Tag of
  0:TNWHostPrinter(Item.Data).Connect;    // Start
  1:with TNWHostPrinter(Item.Data) do Disconnect; // Stop
  2:begin // Delete
   if Application.MessageBox(
    PChar('Voulez-vous supprimer l''imprimante '+Item.Caption+' ?'),
    'Confirmation',
    mb_yesno + mb_iconquestion
   )<>mrYes then exit;
   TNWHostPrinter(Item.Data).Free;
   Item.Free;
  end;
 end;
end;

procedure TForm1.PrinterClose(Sender:TObject);
 begin
  with TNWHostPrinter(Sender),TListItem(Tag) do begin
   if ImageIndex<3 then begin
    ImageIndex:=1;
    SubItems[0]:='END';
    Self.Status:='Imprimante '+DevName+' arrte';
   end;
  end;
 end;

procedure TForm1.PrinterConnect(Sender:TObject);
 begin
  StartStop.Checked:=False; // si on dmarre une imprimante c'est que le serveur n'est plus suspendu
  with TNWHostPrinter(Sender),TListItem(Tag) do begin
   ImageIndex:=2;
   SubItems[0]:='RDY';
   SubItems[1]:='';
//   Self.Status:='Imprimante '+DevName+' Dmarre';
  end;
 end;

procedure TForm1.PrinterError(Sender:TObject);
 begin
  with TNWHostPrinter(Sender),TListItem(Tag) do begin
   ImageIndex:=3;
   SubItems[0]:='ERR';
   SubItems[1]:=ErrorMsg;
   Self.SetStatus('Imprimante '+DevName+' en erreur :'+ErrorMsg);
   Disconnect;
   if Tag<10 then begin
    Tag:=Tag+1;
    Connect; // reconnect
   end;
  end;
 end;

procedure TForm1.PrinterPrintError(Sender:TObject);
 begin
  with TNWHostPrinter(Sender),TListItem(Tag) do begin
   ImageIndex:=3;
   SubItems[0]:='ERR';
   SubItems[1]:=ErrorMsg;
   Self.SetStatus('Erreur d''impression sur '+DevName+' :'+ErrorMsg);
   Disconnect;
  end;
 end;

procedure TForm1.PrinterChange(Sender:TObject);
 begin
  with TNWHostPrinter(Sender),TListItem(Tag) do begin
   ImageIndex:=2;
   SubItems[1]:=Status;
   Self.Status:=DevName+' : '+Status;
  end;
 end;

procedure TForm1.Barredoutils1Click(Sender: TObject);
begin
 pnTools.Visible:=NOT pnTools.Visible;
 TMenuItem(Sender).Checked:=pnTools.Visible;
end;

procedure TForm1.Barredtat1Click(Sender: TObject);
begin
 StatusBar.Visible:=NOT StatusBar.Visible;
 TMenuItem(Sender).Checked:=StatusBar.Visible;
end;

procedure TForm1.Apropos1Click(Sender: TObject);
begin
 with TAboutBox.Create(Application) do begin
  ShowModal;
  Free;
 end;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
var
 i:integer;
begin
 With TForm2.Create(Application) do begin
  ComboBox1.ItemIndex:=2*Stop.H+Stop.M div 30;
  ComboBox2.ItemIndex:=2*Start.H+Start.M div 30;
  if ShowModal=mrOK then begin
   i:=ComboBox1.ItemIndex;
   Stop.H:=i div 2;
   Stop.M:=30*(i and 1);
   i:=ComboBox2.ItemIndex;
   Start.H:=i div 2;
   Start.M:=30*(i and 1);
  end;
  Free;
 end;
end;

procedure TForm1.MinuteTimerTimer(Sender: TObject);
var
 hh,mm,ss,sc:word;
 sav:boolean;
 str:boolean;
 stp:boolean;
begin
// Vrification des Arrtes/Dmarrages
 DecodeTime(now,hh,mm,ss,sc);

// Start AVANT Stop
 sav:=(Start.H<Stop.H)or((Start.H=Stop.H)and(Start.M<Stop.M));
 str:=(hh>Start.h)or((hh=Start.h)and(mm>Start.m));
 stp:=(hh>Stop.h )or((hh=Stop.h )and(mm>Stop.m ));

// Dmarrage
 if StartStop.Checked then begin // Actuellement Suspendu
  Info:='Le serveur dmarrera  '+IntToStr(Start.h)+':'+IntToStr2(Start.m);
  if sav then begin // start AVANT stop
   if (str and (not stp)) then ReleaseServer;
  end else begin
   if (str and stp) then ReleaseServer;
  end;
 end else begin // Actif
  Info:='Le serveur s''arrtera  '+IntToStr(Stop.h)+':'+IntToStr2(Stop.m);
  if sav then begin // start AVANT stop
   if (stp and str) then HoldServer;
  end else begin
   if (stp and (not str)) then HoldServer;
  end;
 end;
end;

procedure TForm1.StartStopClick(Sender: TObject);
begin
 if Listview1.Items.Count=0 then
  StartStop.checked:=False
 else begin
  if StartStop.Checked then ReleaseServer else HoldServer;
 end;
end;

procedure TForm1.ReleaseServer;
 var
  i:integer;
 begin
  StartStop.checked:=False;
  for i:=ListView1.Items.Count-1 downto 1 do begin
   with ListView1.Items[i] do begin
    TNWHostPrinter(Data).Active:=True;
   end;
  end;
  Status:='Serveur dmarr automatique';
 end;

procedure TForm1.HoldServer;
 var
  i:integer;
 begin
  StartStop.checked:=True;
  Status:='Serveur arrt automatique';
  for i:=ListView1.Items.Count-1 downto 1 do begin
   with ListView1.Items[i] do begin
    TNWHostPrinter(Data).Active:=False;
   end;
  end;
 end;

procedure TForm1.SetStatus(Value:string);
 var
  s:string;
 begin
  s:=DateTimeToStr(Now);
  StatusBar.Panels[0].Text:=s;
  StatusBar.Panels[1].Text:=Value;
  Log.Add(s+' '+Value);
  if Log.Count>50 then Log.Delete(0);
  if Form3<>nil then Form3.Memo1.Lines.Assign(Log);
 end;

procedure TForm1.SetInfo(Value:string);
 var
  s:string;
 begin
  s:=DateTimeToStr(Now);
  StatusBar.Panels[0].Text:=s;
  StatusBar.Panels[1].Text:=Value;
 end;

procedure TForm1.Historique1Click(Sender: TObject);
begin
 if Form3=nil then Form3:=TForm3.Create(Application);
 Form3.Memo1.Lines.Assign(Log);
 Form3.Show;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
 CanClose:=Application.MessageBox('Voulez-vous arrter ce serveur d''impression ?','Confirmation',mb_yesno or mb_iconquestion)=mrYes;
end;

end.
