unit NWP4005;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls,Novell;

type
  TForm4 = class(TForm)
    cbTrees: TComboBox;
    lbPrinters: TListBox;
    lbContexts: TListBox;
    OK: TButton;
    Annuler: TButton;
    lbContext: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure cbTreesChange(Sender: TObject);
    procedure lbContextsDblClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Dclarations prives }
    ctx:integer;
    ctname:string;
  public
    { Dclarations publiques }
  end;

var
  Form4: TForm4;

implementation

{$R *.DFM}

procedure TForm4.FormCreate(Sender: TObject);
var
 index,ref:integer;
 buffer:array[0..255] of char;
 i:integer;
begin
 NWDSCreateContextHandle(ctx);
 NWDSGetContext(ctx, DCK_FLAGS,i);
 i:=i or DCV_TYPELESS_NAMES;
 NWDSSetContext(ctx, DCK_FLAGS,i);

 NWDSGetContext(ctx,DCK_NAME_CONTEXT,buffer);
 ctName:='.'+PChar(@Buffer[0]);
 lbContext.Caption:=ctName;

// liste des arbres
 cbTrees.Clear;
 index:=0;
 while NWCCScanConnRefs(index,ref)=0 do begin
  if NWCCGetConnRefInfo(Ref, NWCC_INFO_TREE_NAME, 100, @buffer)=0 then begin
   i:=StrLen(buffer);
   while (i>0)and(buffer[i-1]='_') do dec(i);
   buffer[i]:=#0;
   cbTrees.Items.Add(Buffer);
  end;
 end;
 cbTrees.ItemIndex:=0;
 cbTreesChange(Self);
end;

procedure TForm4.FormDestroy(Sender: TObject);
begin
  NWDSFreeContext(ctx);
end;


procedure TForm4.cbTreesChange(Sender: TObject);
var
 iter:integer;
 buffer:PBuffer;
 count:integer;
 Name:array[0..255] of char;
 info:TObjectInfo;
 attr:integer;
begin
// Liste des Imprimantes & Contexts
 lbContexts.Clear;
 lbPrinters.Clear;

 NWDSAllocBuf({142 is ok for one item ?}4*1024,Buffer);
 try
  iter:=-1;
  if ctName<>'.' then lbContexts.Items.Add('[..]');
  repeat
   if NWDSList(ctx,pchar(ctName),iter,buffer)=0 then
    NWDSGetObjectCount(ctx,buffer,count)
   else begin
    iter:=-1;
    count:=0;
   end;
   while count>0 do begin
    NWDSGetObjectName(ctx,buffer,name,attr,info);
    if (Info.Flags and DS_CONTAINER_ENTRY)>0 then
     lbContexts.Items.Add(strpas(name))
    else begin
     if info.baseClass='Queue' then
     lbPrinters.Items.Add({strpas(info.baseClass)+':'+}strpas(name));
    end;
    dec(count);
   end;
  until iter=-1;
 finally
  NWDSFreeBuf(Buffer);
 end;
end;

procedure TForm4.lbContextsDblClick(Sender: TObject);
var
 i:integer;
 s:string;
begin
// changement de context
 i:=lbContexts.ItemIndex;
 if i<0 then exit;
 s:=lbContexts.Items[i];
 if s='[..]' then begin
  i:=length(ctName);
  while (i>2) and (ctName[i]<>'.') do dec(i);
  SetLength(ctName,i-1);
 end else begin
  if ctName<>'.' then ctName:=ctName+'.';
  ctName:=ctName+s;
 end;
 lbContext.Caption:=ctName;
 cbTreesChange(Self);
end;

end.
