unit NWPDlg;
{
Copyright (C) 2007 Paul Toth <tothpaul@free.fr>
 http://tothpaul.free.fr

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, ImgList;

type
  TNWPrinter = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    tvPrinters: TTreeView;
    OK: TButton;
    Annuler: TButton;
    ImageList1: TImageList;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure tvPrintersExpanding(Sender: TObject; Node: TTreeNode;
      var AllowExpansion: Boolean);
    procedure tvPrintersCompare(Sender: TObject; Node1, Node2: TTreeNode;
      Data: Integer; var Compare: Integer);
    procedure OKClick(Sender: TObject);
  private
    { Dclarations prives }
    Ctx:integer;
    Context:string;
    fPrinter:string;
    fTree:string;
    procedure BuildTreeNode(Node:TTreeNode);
    procedure GetNodePath(Node:TTreeNode;Var Tree,Path:string);
  public
    { Dclarations publiques }
    property Tree:string read fTree write fTree;
    property Printer:string read fPrinter write fPrinter;
  end;

var
  NWPrinter: TNWPrinter;

implementation

{$R *.DFM}

uses
 Novell;

procedure TNWPrinter.FormCreate(Sender: TObject);
var
 i:integer;
 index,ref:integer;
 buffer:array[0..100] of char;
 node:TTreeNode;
 list:TStringList;
 s:string;
begin
//-- Context Handle
 NWDSCreateContextHandle(ctx);
 NWDSGetContext(ctx, DCK_FLAGS,i);
 i:=i or DCV_TYPELESS_NAMES;
 NWDSSetContext(ctx, DCK_FLAGS,i);
//-- Current Context
 Context:='.';
//-- NDS Trees
 index:=0;
 List:=TStringList.Create;
 while NWCCScanConnRefs(index,ref)=0 do begin
  if NWCCGetConnRefInfo(Ref, NWCC_INFO_TREE_NAME, 100, @buffer)=0 then begin
   i:=StrLen(buffer);
   while (i>0)and(buffer[i-1]='_') do dec(i);
   buffer[i]:=#0;
   s:=StrPas(buffer);
   if List.IndexOf(s)<0 then List.add(s);
  end;
 end;
 for i:=0 to List.Count-1 do begin
  node:=tvPrinters.Items.AddChild(nil,List[i]);
  node.ImageIndex:=0;
  node.HasChildren:=True;
 end;
 List.Free;
end;

procedure TNWPrinter.FormDestroy(Sender: TObject);
begin
 NWDSFreeContext(ctx);
end;

procedure TNWPrinter.tvPrintersExpanding(Sender: TObject; Node: TTreeNode;
  var AllowExpansion: Boolean);
begin
 AllowExpansion:=Node.HasChildren;
 if AllowExpansion then begin
  BuildTreeNode(Node);
  AllowExpansion:=Node.HasChildren;
 end;
end;

procedure TNWPrinter.BuildTreeNode(Node:TTreeNode);
 var
  Tree,Path:string;
  Buffer:PBuffer;
  Iter:integer;
  count:integer;
  i:integer;
  Name:array[0..255] of char;
  attr:integer;
  info:TObjectInfo;
 begin
  if (Node.Count>0) then exit;
  tvPrinters.Items.BeginUpdate;

  GetNodePath(Node,Tree,Path);

 // todo: select TREE !!! 

  NWDSAllocBuf(4*1024,Buffer);
  Iter:=-1;
  repeat
   if NWDSList(ctx,pchar(Path),iter,buffer)<>0 then
    Iter:=-1
   else begin
    NWDSGetObjectCount(ctx,buffer,count);
    for i:=1 to Count do begin
     NWDSGetObjectName(ctx,buffer,name,attr,info);
     if (Info.Flags and DS_CONTAINER_ENTRY)>0 then begin
      With tvPrinters.Items.AddChild(Node,Name) do begin
       ImageIndex:=1;
       SelectedIndex:=1;
       HasChildren:=True;
      end;
     end else begin
      if info.baseClass='Queue' then
      With tvPrinters.Items.AddChild(Node,Name) do begin
       ImageIndex:=2;
       SelectedIndex:=2;
       HasChildren:=False;
      end;
     end;
    end;
   end;
  until Iter=-1;

  NWDSFreeBuf(Buffer);

  tvPrinters.AlphaSort;
  tvPrinters.Items.EndUpdate;
  Node.HasChildren:=(Node.Count>0);
 end;

procedure TNWPrinter.GetNodePath(Node:TTreeNode;var Tree,Path:string);
 begin
  Path:='';
  while Node.ImageIndex<>0 do begin
   Path:=Path+'.'+Node.Text;
   Node:=Node.Parent;
  end;
  Tree:=Node.Text;
  if Path='' then Path:=Root;
 end;

procedure TNWPrinter.tvPrintersCompare(Sender: TObject; Node1,
  Node2: TTreeNode; Data: Integer; var Compare: Integer);
begin
 Compare:=Node2.ImageIndex-Node1.ImageIndex;
 if Compare=0 then Compare:=StrComp(pchar(UpperCase(Node1.Text)),pchar(UpperCase(Node2.Text)));
end;

procedure TNWPrinter.OKClick(Sender: TObject);
var
 node:TTreeNode;
begin
 node:=tvPrinters.Selected;
 if node=nil then exit;
 if node.ImageIndex<>2 then exit;
 GetNodePath(tvPrinters.Selected,fTree,fPrinter);
 ModalResult:=mrOK;
end;

end.
