unit NOVELL;
{
Copyright (C) 2007 Paul Toth <tothpaul@free.fr>
 http://tothpaul.free.fr

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

}
interface

type
 nint=integer;
 nptr=pointer;

 nstr=char;
 nuint  =integer;
 nuint8 =byte;
 nuint16=word;
 nuint32=integer;

 NWFLAGS      =byte;
 NWSEGMENT_NUM=byte;
 NWDIR_HANDLE =byte;
 NWOBJ_TYPE   = word;
 NWOBJ_ID     = integer;
 NWCONN_HANDLE=integer;
 NWDSContextHandle=integer;
 NWDSCCODE    =integer;
 NWCCODE      =integer;

 NWCCVersion = Record
  major,minor,revision:integer;
 End;

 LCONV = Record
  decimal_point  :  Array[0..3] Of byte;
  thousands_sep  :  Array[0..3] Of byte;
  grouping  :  Array[0..3] Of byte;
 (*
   The international currency symbol applicable to
   the current locale.  The first three characters
   contain the alphabetic international currency
   symbol in accordance with those specified in ISO
   4217 "codes for the representation of currency
   and funds." The fourth character is the character
   used to separate the international currency
   symbol from the monetary quantity.
  *)
  int_curr_symbol  :  Array[0..7] Of byte;
  currency_symbol  :  Array[0..3] Of byte;
  mon_decimal_point  :  Array[0..3] Of byte;
  mon_thousands_sep  :  Array[0..3] Of byte;
  mon_grouping  :  Array[0..7] Of byte;
  positive_sign  :  Array[0..3] Of byte;
  negative_sign  :  Array[0..3] Of byte;
  int_frac_digits  :  byte;
  frac_digits  :  byte;
  p_cs_precedes  :  byte;
  p_sep_by_space  :  byte;
  n_cs_precedes  :  byte;
  n_sep_by_space  :  byte;
  p_sign_posn  :  byte;
  n_sign_posn  :  byte;
 (* Novell Additions to the ANSI definition:*)
  code_page  :   integer ;
  country_id  :   nint ;
  data_list_separator  :  Array[0..1] Of byte;
  date_separator  :  Array[0..1] Of byte;
  time_separator  :  Array[0..1] Of byte;
  time_format  :  byte;
  date_format  :   integer ;
  am  :  Array[0..4] Of byte;
  pm  :  Array[0..4] Of byte;
  reserved  :  Array[0..39] Of byte;
 end;

 PBuffer = ^TBuffer;
 TBuffer = record
  operation  : integer ;
  flags  :   integer;
  maxLen  :   integer ;
  curLen  :   integer ;
  lastCount  :   ^byte ;
  curPos  :   ^byte ;
  data  :   ^byte ;
 end;

 TObjectInfo = record
  Flags  :   integer ;
  subordinateCount  :   integer ;
  modificationTime  :   integer;
  baseClass  :  Array[0..135] of char;
 End;

const
 MAX_DN_CHARS = 256;
 NWCC_RESERVED= 0;
 DEFAULT_MESSAGE_LEN = ( 4 * 1024 );
 NO_MORE_ITERATIONS = $ffffffff;

 DS_CONTAINER_ENTRY = 4;

 Root:pchar='[Root]';


Function NWLlocaleconv(var Conv:LCONV):integer; stdcall;
function NWLstrupr(s:pchar):pchar; stdcall;
Function NWInitUnicodeTables(Country,codePage:integer):integer; stdcall;

Function NWReadPropertyValue (
        conn  :   integer;
        objName  :   pchar;
        objType  :   integer;
        propertyName  :   pchar;
        segmentNum  :   byte;
        segmentData :pchar;
        var moreSegments,flags  : byte
    ) : integer; stdcall;

Function NWGetObjectID(Conn:integer; ObjName:Pchar; objType:integer; var ObjID:integer):integer; stdcall;

Function NWGetObjectName (
        conn,objID:integer;
        objName  : pchar ;
        var objType: word
    ) : integer;
    stdcall;


Function NWScanObject(
        conn:integer;
        searchName:pchar;
        searchType:word;
    var objID:integer;
        objName:pchar;
    var objType:word;
    var hasPropertiesFlag, objFlags, objSecurity:byte
    ) : integer; stdcall;

Function NWParseNetWarePath(path:PChar; var con:integer; var dir:byte; newpath:pchar):integer; stdcall;
Function NWFileServerFileCopy (srcHandle,dstHandle,srcOffset,dstOffset,srcBytes:integer; var Copied:integer):integer; stdcall;

Type
 TNWQueueJob = packed record
  clientStation,
  clientTask,
  clientID,
  targetServerID:integer;
  targetExecutionTime:array[0..5] of  byte;
  jobEntryTime       :array[0..5] of  byte;
  jobNumber:integer;
  jobType,
  jobPosition,
  jobControlFlags:word;
{  CheckBoxUserHold.Checked := (job2.jobControlFlags and $40)>0;
   CheckBoxOpHold.Checked   := (job2.jobControlFlags and $80)>0;
}
  jobFileName:array[0..13] of char;
  jobFileHandle,
  servicingServerStation,
  servicingServerTask,
  servicingServerID:integer;
  jobDescription:array[0..49] of char;
//  clientRecordArea:array[0..151] of byte;
   version:byte; // 1 ?
   tabSize:byte;
   numberOfCopiesHi, // Copies=Copies+256*CopiesHiByte -> http://developer.novell.com/support/bullets/oct94.htm
   numberOfCopies:byte;
   printControlFlags:word;
   maxLinesPerPageHi,
   maxLinesPerPage,
   maxCharsPerLineHi,
   maxCharsPerLine:byte;
   formName:array[0..15] of char;
   reserve :array[0.. 5] of char;
   bannerNameField:array[0..12] of char;
   bannerFileField:array[0..12] of char;
   headerFileName :array[0..13] of char;
   directoryPath  :array[0..79] of char;
 end;

const
 QF_AUTO_START = $08;
 QF_ENTRY_RESTART = $10;
 QF_ENTRY_OPEN = $20;
 QF_USER_HOLD = $40;
 QF_OPERATOR_HOLD = $80;

 KEEP_ON        =$0400;
 NO_FORM_FEED   =$0800;
 NOTIFICATION   =$1000;
 DELETE_FILE    =$2000;
 EXPAND_TABS    =$4000;
 PRINT_BANNER   =$8000;


function NWCloseFileAndAbortQueueJob2(Conn,queue,job,hFile:integer):integer; stdcall;
function NWCloseFileAndStartQueueJob2(Conn,queue,job,hFile:integer):integer; stdcall;
Function NWCreateQueueFile2(Conn,queue:integer; Var job:TNWQueueJob;var hFile:integer):integer; stdcall;
Function NWCallsInit(Reserved1,Reserved2:pointer):integer; stdcall;

const  (* Name Format types *)
 NWCC_NAME_FORMAT_NDS = $0001;
 NWCC_NAME_FORMAT_BIND = $0002;
 NWCC_NAME_FORMAT_NDS_TREE = $0008;

const (* Transport types *)
 NWCC_TRAN_TYPE_IPX = $00000001;
 NWCC_TRAN_TYPE_UDP = $00000002;
 NWCC_TRAN_TYPE_DDP = $00000003;
 NWCC_TRAN_TYPE_ASP = $00000004;
 NWCC_TRAN_TYPE_WILD = $00008000;

function NWCCOpenConnByName(Conn:integer; Name:PChar; Fmt,State,tType:integer; var Handle:integer):integer; stdcall;
Function NWCCGetPrimConnRef(Var Ref:integer):integer; stdcall;

Const (* Open States *)
 NWCC_OPEN_LICENSED        = $0001;
 NWCC_OPEN_UNLICENSED      = $0002;
 NWCC_OPEN_PRIVATE         = $0004;
 NWCC_OPEN_PUBLIC          = $0008;
 NWCC_OPEN_EXISTING_HANDLE = $0010;

Function NWCCOpenConnByRef(Ref,State,Reserved:integer; var Conn:integer):integer; stdcall;
function NWCCCloseConn(conn:integer):integer; stdCall;
Function NWCCSysCloseConnRef(Ref:integer):integer; stdcall;
Function NWCCGetConnRef(Conn:integer; var ref:integer):integer; stdcall;
Function NWCCScanConnRefs(var scan,ref:integer):integer; stdcall;

Const
  NWCC_INFO_NONE            = 0;
  NWCC_INFO_AUTHENT_STATE   = 1;
  NWCC_INFO_BCAST_STATE     = 2;
  NWCC_INFO_CONN_REF        = 3;
  NWCC_INFO_TREE_NAME       = 4;
  NWCC_INFO_CONN_NUMBER     = 5;
  NWCC_INFO_USER_ID         = 6;
  NWCC_INFO_SERVER_NAME     = 7;
  NWCC_INFO_NDS_STATE       = 8;
  NWCC_INFO_MAX_PACKET_SIZE = 9;
  NWCC_INFO_LICENSE_STATE   = 10;
  NWCC_INFO_DISTANCE        = 11;
  NWCC_INFO_SERVER_VERSION  = 12;
  NWCC_INFO_TRAN_ADDR       = 13;
  NWCC_INFO_RETURN_ALL      = $FFFF;

 (* License States *)
  NWCC_NOT_LICENSED        = $0000;
  NWCC_CONNECTION_LICENSED = $0001;
  NWCC_HANDLE_LICENSED     = $0002;

Function NWCCGetConnRefInfo(conn,info,len:integer; buffer:pointer):integer; stdcall;

Const
 ERR_CONTEXT_CREATION = 328;
function NWDSCreateContext:integer; StdCall;
function NWDSFreeContext(Context:integer):integer;  StdCall;
Const (* Directory Context Key names *)
 DCK_FLAGS = 1;
 DCK_CONFIDENCE = 2;
 DCK_NAME_CONTEXT = 3;
 DCK_TRANSPORT_TYPE = 4;
 DCK_REFERRAL_SCOPE = 5;
 DCK_LAST_CONNECTION = 8;
 DCK_LAST_SERVER_ADDRESS = 9;
 DCK_LAST_ADDRESS_USED = 10;
 DCK_TREE_NAME = 11;
 DCK_DSI_FLAGS = 12;
 DCK_NAME_FORM = 13;
 DCK_NAME_CACHE_DEPTH = 15;

 (* DCK_FLAGS bit values key *)
 DCV_DEREF_ALIASES = $00000001;
 DCV_XLATE_STRINGS = $00000002;
 DCV_TYPELESS_NAMES = $00000004;
 DCV_ASYNC_MODE = $00000008;
 DCV_CANONICALIZE_NAMES = $00000010;
 DCV_DEREF_BASE_CLASS = $00000040;
 DCV_DISALLOW_REFERRALS = $00000080;

Function NWDSGetContext(Context,Key:integer; var value):integer; stdcall;
Function NWDSSetContext(Context,Key:integer; var Value):integer; stdcall;
Function NWDSAllocBuf(Size:integer;Var Buf:PBuffer):integer; stdcall;
Function NWDSFreeBuf (Buf:PBuffer):integer; stdcall;
Function NWDSGetObjectCount(Context:integer; Buf:PBuffer; var count:integer):integer; stdcall;
Function NWDSGetObjectName(Context:integer;  Buf:PBuffer; Name:PChar;var Count:integer; var Info:TObjectInfo):integer; stdcall;
Function NWDSList(Context:integer; objName:PChar; var iter:integer; Buf:PBuffer):integer; stdcall;
Function NWDSMapIDToName(Context,Conn,ObjID:integer; Name:pchar):integer; stdcall;
Function NWDSWhoAmI(Context:integer; Name:Pchar):integer; stdcall;
Function NWDSMoveObject(Context:integer; OldName,Target,NewName:PChar):integer; stdcall;
Function NWDSMapNameToID(Context,Conn:integer; Name:PChar;var id:integer):integer; stdcall;
Function NWDSCreateContextHandle(Var Handle:integer):integer; stdcall;

// Tools

Function NWReadString(Context:integer; Obj,Key:string; Var Value:string):integer;

implementation

uses
 sysutils;

const
 DSV_READ = 3;
const (* * definitions used by DSV_READ, DSV_SEARCH * *)
 DS_ATTRIBUTE_NAMES = $00;
 DS_ATTRIBUTE_VALUES = $01;
 DS_EFFECTIVE_PRIVILEGES = $02;
 DS_VALUE_INFO = $03;
 DS_ABBREVIATED_VALUE = $04;

Function NWDSInitBuf(Context,Operation:integer; Buffer:PBuffer):integer; far; stdcall external 'netwin32.dll' index 1005;
Function NWDSGetAttrCount(Context:integer; Buffer:PBuffer; Var count:integer):integer; far; stdcall external 'netwin32.dll' index 1008;
Function NWDSGetAttrName(Context:integer; Buffer:PBuffer; Attr:PChar; Var Count,ID:integer):integer; far; stdcall external 'netwin32.dll' index 1013;
Function NWDSPutAttrName(Context:integer; Buffer:PBuffer; Name:PChar):integer; far; stdcall external 'netwin32.dll' index 1015;
Function NWDSGetAttrVal(Context:integer; Buffer:PBuffer; ID:integer; Var Value):integer; far; stdcall external 'netwin32.dll' index 1022;
Function NWDSRead(Context:integer; Obj:PChar; InfoType:integer; All:boolean; Names:PBuffer; var Iter:integer; Info:PBuffer):integer; far; stdcall external 'netwin32.dll' index 1028;
Function NWDSComputeAttrValSize(Context:integer; Buffer:PBuffer; ID:integer; var Size:integer):integer; far; stdcall external 'netwin32.dll' index 1047;

var
 NWError:integer;

procedure error(i:integer);
 begin
  NWError:=i;
  if i<>0 then raise Exception.Create('Erreur Netware');
 end;

Function NWReadString(Context:integer; Obj,Key:string; Var Value:string):integer;
 var
  Buffer:PBuffer;
  Iter:integer;
  Values:PBuffer;
  Count,ID:integer;
  Size:integer;
 begin
  try
   error(NWDSAllocBuf(4*1024,Buffer));
   error(NWDSAllocBuf(4*1024,Values));
   try
    error(NWDSInitBuf(Context,DSV_READ,Buffer));
    error(NWDSInitBuf(Context,DSV_READ,Values));

    error(NWDSPutAttrName(Context,Buffer,PChar(Key)));
    Iter:=-1;
    error(NWDSRead(Context,PChar(Obj),DS_ATTRIBUTE_VALUES,False,Buffer,Iter,Values));
    error(NWDSGetAttrCount(Context,Values,Count)); // need for NWDSGetAttrName ?!
    if count=0 then begin
     value:='';
     result:=-1;
    end else begin
     error(NWDSGetAttrName(Context,Values,@Key[1],Count,ID));
     error(NWDSComputeAttrValSize(Context,Values,ID,Size));
     SetLength(Value,Size);
     error(NWDSGetAttrVal(Context,Values,ID,Value[1]));
     Value:=StrPas(PChar(Value)); // remove #0
     result:=0;
    end;
   finally
    NWDSFreeBuf(Values);
    NWDSFreeBuf(Buffer);
   end;
  except
   value:=IntToHex(NWError,8);
   result:=NWError;
  end;
 end;

//--------

function NWLlocaleconv;  StdCall; external 'locwin32.dll' index 1;
function NWLstrupr;  stdcall; external 'locwin32.dll' index 38;
function NWInitUnicodeTables;  StdCall; external 'locwin32.dll' index 63;

function NWReadPropertyValue;  StdCall; external 'calwin32.dll' index 19;
function NWGetObjectID;  StdCall; external 'calwin32.dll' index 25;
function NWGetObjectName;  StdCall; external 'calwin32.dll' index 26;
function NWScanObject; stdcall; external 'calwin32.dll' index 27;
function NWParseNetWarePath;  StdCall; external 'calwin32.dll' index 103;
function NWFileServerFileCopy;  StdCall; external 'calwin32.dll' index 107;
function NWCloseFileAndAbortQueueJob2;  StdCall; external 'calwin32.dll' index 235;
function NWCloseFileAndStartQueueJob2;  StdCall; external 'calwin32.dll' index 236;
function NWCreateQueueFile2;  StdCall; external 'calwin32.dll' index 237;
function NWCallsInit;  StdCall; external 'calwin32.dll' index 377;

function NWCCOpenConnByName;  StdCall; external 'clxwin32.dll' index 100;
function NWCCGetPrimConnRef;  StdCall; external 'clxwin32.dll' index 111;
function NWCCOpenConnByRef;  StdCall; external 'clxwin32.dll' index 102;
function NWCCCloseConn;  StdCall; external 'clxwin32.dll' index 103;
function NWCCSysCloseConnRef;  StdCall; external 'clxwin32.dll' index 104;
function NWCCGetConnRef;  StdCall; external 'clxwin32.dll' index 108;
function NWCCScanConnRefs;  StdCall; external 'clxwin32.dll' index 113;
function NWCCGetConnRefInfo;  StdCall; external 'clxwin32.dll' index 115;

function NWDSCreateContext;  StdCall; external 'netwin32.dll' index 1001;
function NWDSFreeContext;  StdCall; external 'netwin32.dll' index 1002;
function NWDSGetContext;  StdCall; external 'netwin32.dll' index 1003;
function NWDSSetContext;  StdCall; external 'netwin32.dll' index 1004;
function NWDSAllocBuf;  StdCall; external 'netwin32.dll' index 1006;
function NWDSFreeBuf;  StdCall; external 'netwin32.dll' index 1007;
function NWDSGetObjectCount;  StdCall; external 'netwin32.dll' index 1011;
function NWDSGetObjectName;  StdCall; external 'netwin32.dll' index 1014;
function NWDSList;  StdCall; external 'netwin32.dll' index 1023;
function NWDSMapIDToName;  StdCall; external 'netwin32.dll' index 1048;
function NWDSMapNameToID;  StdCall; external 'netwin32.dll' index 1050;
function NWDSWhoAmI;  StdCall; external 'netwin32.dll' index 1093;
function NWDSMoveObject;  StdCall; external 'netwin32.dll' index 1137;
function NWDSCreateContextHandle;  StdCall; external 'netwin32.dll' index 1160;

end.
