unit Imp4001;

{
Copyright (C) 2007 Paul Toth <tothpaul@free.fr>
 http://tothpaul.free.fr

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

}

interface
{-$define localcopy} // make a local copy of the program (usefull when launched from a shared drive)
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ImgList, ComCtrls, Buttons, HstPrint,
  Menus, Links,ShellAPI;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    bdStart: TSpeedButton;
    bdStop: TSpeedButton;
    bdProperty: TSpeedButton;
    Bevel2: TBevel;
    Panel2: TPanel;
    Shape1: TShape;
    Image1: TImage;
    Panel3: TPanel;
    Label1: TLabel;
    SpeedButton1: TSpeedButton;
    SaveDlg: TSaveDialog;
    procedure btTagClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Apropos1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure HostPrinter1Connect(Sender: TObject);
    procedure HostPrinter1Close(Sender: TObject);
    procedure HostPrinter1Error(Sender: TObject);
    procedure bdPropertyClick(Sender: TObject);
    procedure HostPrinter1Print(Sender: TObject);
    procedure HostPrinter1Change(Sender: TObject);
    procedure Image1DblClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
  private
    { Dclarations prives }
    exepath:string;
    HostPrinter1:THostPrinter;
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

Uses
 RegEdit,HPSetup, Imp400A;

{$R *.DFM}

function IntToStr2(i:integer):string;
 begin
  Result:=IntToStr(i);
  if length(Result)=1 then Result:='0'+Result;
 end;

procedure TForm1.FormCreate(Sender: TObject);
var
 i:integer;
 s:string;
 fs,ss:TFileStream;
begin
// Composant non install
  HostPrinter1:=THostPrinter.Create(Self);
  with HostPrinter1 do begin
    Active := False;
    MSQG := '*LIBL/QSYSOPR';
    Model := '*HPIII';
    Paper1 := '*A4';
    Paper2 := '*NONE';
    Envelope := '*NONE';
    Font := '12';
    FormFeed := 'C';
    OnConnect := HostPrinter1Connect;
    OnChange := HostPrinter1Change;
    OnError := HostPrinter1Error;
    OnClose := HostPrinter1Close;
    OnPrint := HostPrinter1Print;
    OnPrintError := HostPrinter1Error;
  end;

//
 i:=1;
 exepath:=Application.ExeName;
{$ifdef localcopy}
 if UpperCase(copy(exepath,1,2))='C:' then begin
  if paramstr(1)='-l' then begin // C:TMP400.EXE -l "m:imp400.exe" CmdLine
   i:=3;
   exepath:=paramstr(2);
  end;
 end else begin // M:IMP400.EXE CmdLine
  SetLength(s,128);
  SetLength(s,GetTempPath(128,pchar(s)));
  if s='' then s:='c:\';
  s:=s+'TMP400.EXE';
  fs:=nil;
  ss:=nil;
  try
   try
    fs:=TFileStream.Create(s,fmOpenWrite or fmCreate);
    ss:=TFileStream.Create(Application.ExeName,fmOpenRead or fmShareDenyNone);
    fs.CopyFrom(ss,ss.Size);
   except
    // Si erreur de cration
   end;
  finally
   ss.Free;
   fs.Free;
  end;
  exepath:='-l '+CmdLine;
  ShellExecute(0,nil,pchar(s),pchar(exepath),nil,cmdshow);
  halt;
 end;
{$endif}
 if ParamCount>=i then begin
// IMP400.EXE "HP LaserJet III" HOSTNAME PR5250 *HPIII *A4
  with HostPrinter1 do begin
   Printer :=ParamStr(i); inc(i);
   HostName:=ParamStr(i); inc(i);
   DevName :=ParamStr(i); inc(i);
   s:=ParamStr(i);  inc(i);
   if s='*WSCST' then begin
    WSCST:=ParamStr(i);
    inc(i);
   end;
   Model   :=s;
   Paper1  :=ParamStr(i); inc(i);
   HostPrinter1.Connect;
   if HostPrinter1.Active and (ParamStr(i)='/hide') then WindowState:=wsMinimized;
  end;
 end else begin
  if HostPrinter1.Setup then HostPrinter1.Connect;
 end;
end;

procedure TForm1.btTagClick(Sender: TObject);
begin
 case TControl(Sender).Tag of
  0:HostPrinter1.Connect;    // Start
  1:HostPrinter1.Disconnect; // Stop
 end;
end;

procedure TForm1.Apropos1Click(Sender: TObject);
begin
 with TAboutBox.Create(Application) do begin
  ShowModal;
  Free;
 end;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
 CanClose:=
  (HostPrinter1.Active=false)
 or
  (Application.MessageBox('Voulez-vous arrter la session imprimante ?','Confirmation',mb_yesno or mb_iconquestion)=mrYes);
end;

procedure TForm1.HostPrinter1Connect(Sender: TObject);
begin
 Label1.Caption:='L''imprimante est dmarre, vous pouvez lancer vos impressions';
 Shape1.Brush.Color:=clLime;
 Application.Title:=HostPrinter1.DevName;
 Caption:=HostPrinter1.DevName+' - Imprimante AS/400';
end;

procedure TForm1.HostPrinter1Close(Sender: TObject);
begin
 Label1.Caption:='Cliquez sur "Dmarrer" pour activer la session imprimante.';
 Shape1.Brush.Color:=clBlack;
end;

procedure TForm1.HostPrinter1Error(Sender: TObject);
begin
 Label1.Caption:=HostPrinter1.ErrorMsg;
// Label1.Hint:=WindowsError;
 Shape1.Brush.Color:=clRed;
end;

procedure TForm1.bdPropertyClick(Sender: TObject);
begin
 if HostPrinter1.Setup then begin
  if HostPrinter1.Active then begin
   MessageBox(Handle,'Redmarrez la session pour activer les changements'#13'Et n''oubliez pas de sauvegarder la session !','Attention',mb_iconInformation or mb_OK);
  end;
 end;
end;

procedure TForm1.HostPrinter1Print(Sender: TObject);
begin
 if HostPrinter1.Printing then begin
  Image1.Hint:='Impression en cours...';
  if Shape1.Brush.Color=clLime then Shape1.Brush.Color:=clRed else Shape1.Brush.Color:=clLime;
 end else begin
  Image1.Hint:='Prte.';
  Shape1.Brush.Color:=clLime;
 end;
end;

procedure TForm1.HostPrinter1Change(Sender: TObject);
begin
 Label1.Hint:=HostPrinter1.Status;
end;

procedure TForm1.Image1DblClick(Sender: TObject);
begin
 HostPrinter1.Setup;
end;

Function WindowPath(Value:string):string;
 begin
// HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders
  Result:=ReadRegString(HKEY_CURRENT_USER,'Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders',Value,'???');
 end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
var
 s:string;
begin
 SaveDlg.FileName:=WindowPath('Desktop')+'\'+HostPrinter1.DevName+' ('+HostPrinter1.HostName+').lnk';
 if SaveDlg.Execute then begin
  with HostPrinter1 do begin
   s:='"'+Printer+'" '+HostName+' '+DevName+' '+Model;
   if Model='*WSCST' then s:=s+' '+WSCST;
   s:=s+' '+Paper1;
   CreateLink(SaveDlg.FileName,exepath,s);
   if Application.MessageBox('Voulez vous lancer cette session Automatiquement ?','Confirmation',mb_yesno or mb_iconquestion)=mrYes then begin
    CreateLink(WindowPath('Startup')+'\'+DevName+'.lnk',exepath,s+' /hide');
   end;
  end;
 end;
end;

end.
